=== debian/changelog ===
mujoco (2.2.0-2) unstable; urgency=medium

  * Refresh symbols.

 -- Mo Zhou <lumin@debian.org>  Sat, 23 Jul 2022 18:41:24 -0700

mujoco (2.2.0-1) unstable; urgency=medium

  * Refresh symbols for GCC-12.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 23 Jul 2022 13:18:59 -0700

mujoco (2.2.0-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1011667)

 -- Mo Zhou <lumin@debian.org>  Sat, 09 Jul 2022 21:23:59 -0700
