=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem cmake+ninja

override_dh_auto_configure:
	# absl mismatch. not building tests now.
	dh_auto_configure -- \
		-DBUILD_TESTING=OFF \
		-DMUJOCO_ENABLE_AVX=OFF \
		-DMUJOCO_ENABLE_AVX_INTRINSICS=OFF

override_dh_auto_test:
	:
